#include <assert.h>
#include "bitmap.h"

// Define  window
SimpleWindow W1("Window One", 25.0, 15.0, Position(1.0, 1.0));

// Define a bitmap object
BitMap W1Bmp(W1);

// W1MouseClick(): call back function for Window one
int W1MouseClick(const Position &p) {
	// Erase the bitmap
	W1Bmp.Erase();
	// Set its new position and display it
	W1Bmp.SetPosition(p);
	W1Bmp.Draw();
	return 1;
}

int ApiMain() {

	// Open the windows
	W1.Open();
	assert(W1.GetStatus() == WindowOpen);

	// Load the images
	// **********************
	// Is the image not in xpm format?  Don't worry, use the convert
	// command.  E.g. if you have image.bmp, use the following:
	//     convert image.bmp image.xpm 
	// **********************
	 W1Bmp.Load("scene1.xpm");
//	W1Bmp.Load("fingerprint11.xpm");
	//W1Bmp.Load("trbot-r.xpm");
	assert(W1Bmp.GetStatus() == BitMapOkay);

	// Display the bit maps at a starting position
	W1Bmp.SetPosition(Position(1.0, 1.0));
	W1Bmp.Draw();

	// Register the call backs for each window
	W1.SetMouseClickCallback(W1MouseClick);
	return 0;
}

